/*
 * Cree a partir de BlackJackCommon.h par Shimon Whiteson
 * Auteur : Pierre Garard pierre.gerard@lipn.univ-paris13.fr
 *
 * Environnement Blackjack semblable  celui dcrit dans le Sutton et Barto, section 5.1
 *
 * Observations : int*
 * - int[0] : total du joueur
 * - int[1] : total du donneur
 * - int[3] : le joueur a-t-il un as utilisable ?
 * Actions : int
 * - 0,1 pour determiner si le joueur arrte ou tire une nouvelle carte
 * Rcompense : float
 * - -1 si le jouer perd
 * - 1 si le joueur gagne
 * - 0 en cas d'egalite
 *
 * Tache episodique
 */

#ifndef BLACKJACK_H
#define BLACKJACK_H

#include "RLcommon.h"

// global observation and reward variables
Observation observation;
Reward_observation rewOb;

// global state information
int playerTotal;				 // current value of player's hand
int dealerTotal;				 // current value of dealer's hand

bool playerUsableAce;			 // whether the player has a usable ace
bool dealerUsableAce;			 // whether the agent has a usable ace

// update global obvservation variable
void setObservation();

// add a new card to a player's total, handle usuable aces
void addCard(int& total, bool& usableAce);
#endif
