/*
 * Cree a partir de BlackJackCommon.h par Shimon Whiteson
 * Auteur : Pierre Garard pierre.gerard@lipn.univ-paris13.fr
 *
 * Environnement Blackjack semblable  celui dcrit dans le Sutton et Barto, section 5.1
 *
 * Observations : int*
 * - int[0] : total du joueur
 * - int[1] : total du donneur
 * - int[3] : le joueur a-t-il un as utilisable ?
 * Actions : int
 * - 0,1 pour determiner si le joueur arrte ou tire une nouvelle carte
 * Rcompense : float
 * - -1 si le jouer perd
 * - 1 si le joueur gagne
 * - 0 en cas d'egalite
 *
 * Tache episodique
 */

#ifndef BJ_COMMON_H
#define BJ_COMMON_H

// An observation is an array of three integers
// 0th element: current value of player's hand
// 1st element: current value of dealer's hand
// 2nd element: 0 -> player does NOT have usable ace

#define AGENT_INIT
#define ENV_INIT
#define AGENT_CLEANUP
#define ENV_CLEANUP

// An action is an integer
// 0 -> player hits
// 1 -> player sticks
typedef int Action;
typedef int* Observation;

typedef char* Task_specification;
typedef double Reward;

typedef struct
{
	Reward r;
	Observation o;
	bool terminal;
} Reward_observation;

typedef int State_key;
typedef int Random_seed_key;
#endif
