/*
 * Cree a partir de catMouse.cpp (voir le site de RL-Glue)
 * Auteur de cette version : Pierre Gérard pierre.gerard@lipn.univ-paris13.fr
 *
 * Environnement de type Gridworld avec des obstacles, des trous de souris, un chat et du fromage
 * Le chat ne peut pas accéder aux cases "trou de souris"
 * Le chat est egreedy en regard du rapprochement de la souris
 *
 * Observations : int*
 * - int[0] : colonne de l'agent souris
 * - int[1] : ligne de l'agent souris
 * - int[2] : colonne du chat
 * - int[3] : ligne du chat
 * Actions : int
 * - 0..7 pour les huit directions
 * Récompense : float, typiquement, on met
 * - -10 si la souris et le chat se trouvent sur la meme case
 * - +5 si la souris se trouve sur une case fromage
 *
 * Tache episodique : un épisode se termine quand le chat et la souris sont sur la meme case (RIP la souris) 
 * Chaque episode, le point de depart est choisi aleatoirement
 */

#ifndef CAT_COMMON_H
#define CAT_COMMON_H

#define AGENT_INIT
#define ENV_INIT
#define AGENT_CLEANUP
#define ENV_CLEANUP

// An action is an integer
// 0 -> player hits
// 1 -> player sticks
typedef int Action;
typedef int* Observation;

typedef char* Task_specification;
typedef double Reward;

typedef struct
{
	Reward r;
	Observation o;
	bool terminal;
} Reward_observation;

typedef int State_key;
typedef int Random_seed_key;
#endif
