/*
 * Cree a partir de MountainCar.cpp cree par Rich Sutton puis modifie par Adam White
 * Auteur : Pierre Grard pierre.gerard@lipn.univ-paris13.fr
 *
 * Environnement de type Gridworld avec des mines, des obstacles et un but
 * Les grilles sont generees aleatoirement
 *
 * Observations : float*
 * - float[0] : position de la voiture
 * - float[1] : vitesse de la voiture
 * Actions : int
 * - accélération vers la gauche, sur place, accélération vers la droite
 * Rcompense : float
 * - 100 si le but est atteint
 * - -100 si le délai de 10000 est dépassé
 * - -1 sinon
 *
 * Tache episodique
 */

#ifndef MOUNTAINCAR_H
#define MOUNTAINCAR_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <unistd.h>
#include "RLcommon.h"

//State variables
double mcar_position;
double mcar_velocity;

int numActions = 3;
int stateSize = 2;

//Step variables
#define mcar_min_position -1.2
#define mcar_max_position 0.6
#define mcar_max_velocity 0.07	 // the negative of this is also the minimum velocity
#define mcar_goal_position 0.5
#define POS_WIDTH (1.7 / 8)		 // the tile width for position
#define VEL_WIDTH (0.14 / 8)	 // the tile width for velocity

bool mcar_goal();	
void env_print(Action action);			 // Is Car within goal region?

Observation o;					 //instance of Sensation type
Reward_observation ro;			 //instance of observation type
#endif
