/*
 * Cree a partir de MountainCar.cpp cree par Rich Sutton puis modifie par Adam White
 * Auteur : Pierre Grard pierre.gerard@lipn.univ-paris13.fr
 *
 * Environnement de type Gridworld avec des mines, des obstacles et un but
 * Les grilles sont generees aleatoirement
 *
 * Observations : float*
 * - float[0] : position de la voiture
 * - float[1] : vitesse de la voiture
 * Actions : int
 * - accélération vers la gauche, sur place, accélération vers la droite
 * Rcompense : float
 * - 100 si le but est atteint
 * - -100 si le délai de 10000 est dépassé
 * - -1 sinon
 *
 * Tache episodique
 */

#ifndef CAR_COMMON_H
#define CAR_COMMON_H

//This tells interface that you will provide definitions for optional functions: env_init, agent_init, and agent_clean.
//See DOC for list of optional functions and flags that allow implementation of some or all of these methods
#define ENV_INIT
#define AGENT_INIT
#define AGENT_CLEANUP
#define ENV_CLEANUP

typedef double* Observation;	 //Defining what type a sensation is
typedef int Action;				 //Defining what type a action is

typedef char* Task_specification;
typedef double Reward;

typedef struct
{
	Reward r;
	Observation o;
	bool terminal;
} Reward_observation;

typedef int State_key;
typedef int Random_seed_key;
#endif
